/*
   Coolpix RAW to Coolpix NEF converter
   by paul69, v0.05, 2003-01-29, <e2500@narod.ru>

   RAW Data Reader 

   Supported camera (tested)
      E2500
      E4500
      E995
      E950
*/

#include <stdio.h>
#include <string.h>
#pragma hdrstop

#include "raw2nef.h"

bool read_raw(FILE* in, color_t ccd[], TCCDParam& ccd_pars)
{
   unsigned raw_width = ccd_pars.raw_width;
   unsigned ccd_size = raw_width * ccd_pars.raw_height;

   for(int f=0; f<2; ++f)
   {
      if( ccd_pars.field[f].rows == 0 ) continue;

      unsigned line = f * raw_width;
      unsigned delta = 2 * raw_width;

      unsigned i, x;

      if( ccd_pars.bits_per_sample == 12 )
      {
         fseek( in, ccd_pars.field[f].offset, SEEK_SET );
         unsigned field_size = ccd_pars.field[f].rows * ccd_pars.row_length;

         for(x=i=0; i<field_size; i += 3)
         {
            byte bitbuf[3];
            if( !fread( bitbuf, 3, 1, in) )
               return false;

            if( x == raw_width )
            {
               line += delta;
               x = 0;

               // check space for row
               if( line + raw_width > ccd_size )
                  return false;
            }

            ccd[line + x] = (color_t)(((bitbuf[0]<<4)|((bitbuf[1]>>4)&15)));
            ++x;

            ccd[line + x] = (color_t)((((bitbuf[1]&15)<<8)|(bitbuf[2])));
            ++x;
         }
      }
      else
      if( ccd_pars.bits_per_sample == 10 )
      {
         unsigned row_offset = ccd_pars.field[f].offset;
         unsigned rows = ccd_pars.field[f].rows;
         int row_size = ccd_pars.row_length;

         for(int y=0; y<rows; ++y,
            row_offset += row_size, line += delta)
         {
            // check space for row
            if( line + raw_width > ccd_size )
               return false;

            fseek( in, row_offset, SEEK_SET );

            for(x=i=0; i<row_size; i += 5)
            {
               byte bitbuf[5];

               if( !fread( bitbuf, 5, 1, in) )
                  return false;

               // unpack 5 bytes to 4 samples, each sample multiplay by 4
               ccd[line + x] = (color_t)((((unsigned)bitbuf[0]<<2)|((bitbuf[1]>>6)&3))<<2);
               if( ++x == raw_width ) break;

               ccd[line + x] = (color_t)((((bitbuf[1]&63)<<4)|((bitbuf[2]>>4)&15))<<2);
               if( ++x == raw_width ) break;

               ccd[line + x] = (color_t)((((bitbuf[2]&15)<<6)|((bitbuf[3]>>2)&63))<<2);
               if( ++x == raw_width ) break;

               ccd[line + x] = (color_t)((((bitbuf[3]&3)<<8)|(bitbuf[4]))<<2);
               if( ++x == raw_width ) break;
            }
         }
      }
      else
         return false;
   }
   return true;
}

